## chaosvpn-2014-01-24-2eb24810b5aa0b2d56f21562e52927020dc3090a.tar.gz

=== Makefile ===
CC?=gcc
INCLUDES?=-I/usr/local/include
LIBDIRS?=-L/usr/local/lib
LIB?=-lz -lcrypto

OS=$(shell uname)
ifneq (,$(findstring BSD,$(OS)))
	# hopefully FreeBSD, OpenBSD, NetBSD
	CFLAGS+=-DBSD -std=c99 -D_FILE_OFFSET_BITS=64 -O2 -Wall -g $(INCLUDES)
	PREFIX?=/usr/local
	TINCDIR?=/usr/local/etc/tinc
else
ifneq (,$(findstring Darwin,$(OS)))
	# Apple OSX / Darwin
	CFLAGS+=-DBSD -std=c99 -D_FILE_OFFSET_BITS=64 -O2 -Wall -g $(INCLUDES)
	PREFIX?=/usr/local
	TINCDIR?=/usr/local/etc/tinc
else
	# Linux by default
	CFLAGS+=-std=c99 -D_POSIX_C_SOURCE=2 -D_BSD_SOURCE -D_FILE_OFFSET_BITS=64 -O2 -Wall -g $(INCLUDES)
	PREFIX?=/usr
	TINCDIR?=/etc/tinc
endif
endif
ifneq (,$(findstring mingw,$(CC)))
	CFLAGS+=-DWIN32
	LIB+=-lws2_32 -lgdi32
endif

LEX=flex
YACC?=yacc

CFLAGS += -DPREFIX="\"$(PREFIX)\"" -DTINCDIR="\"$(TINCDIR)\""

STRINGSRC=string/string_clear.c string/string_concatb.c string/string_concat_sprintf.c string/string_putc.c string/string_putint.c string/string_concat.c string/string_free.c string/string_get.c string/string_init.c string/string_equals.c string/string_move.c string/string_initfromstringz.c string/string_lazyinit.c string/string_read.c string/string_hexdump.c
HTTPLIBSRC=httplib/http_get.c httplib/http_parseurl.c
SRC = tinc.c fs.c parser.c tun.c y.tab.c lex.yy.c config.c strnatcmp.c daemon.c crypto.c ar.c uncompress.c log.c pidfile.c addrmask.c $(STRINGSRC) $(HTTPLIBSRC)
HEADERS = chaosvpn.h list.h strnatcmp.h version.h y.tab.h addrmask.h httplib/httplib.h string/string.h
STRINGOBJ=$(patsubst %.c,%.o,$(STRINGSRC))
HTTPLIBOBJ=$(patsubst %.c,%.o,$(HTTPLIBSRC))
OBJ=$(patsubst %.c,%.o,$(SRC))

NAME?=chaosvpn
GITDEBVERSION=$(shell debian/scripts/calcdebversion )

all: $(NAME)

$(NAME): main.o $(OBJ) $(HEADERS)
	$(CC) $(LDFLAGS) -o $@ main.o $(OBJ) $(LIB) $(LIBDIRS)

test_addrmask: test_addrmask.o $(OBJ) $(HEADERS)
	$(CC) $(LDFLAGS) -o $@ test_addrmask.o $(OBJ) $(LIB) $(LIBDIRS)

%.o: %.c $(HEADERS)
	$(CC) $(CFLAGS) -o $(patsubst %.c,%.o,$<) -c $<

lex.yy.o: lex.yy.c y.tab.h

y.tab.c y.tab.h: cvconf.y
	$(YACC) -d cvconf.y

lex.yy.c: cvconf.l
	$(LEX) cvconf.l

clean:
	rm -f *.o y.tab.c y.tab.h lex.yy.c string/*.o httplib/*.o $(NAME) test_addrmask

CHANGES:
	[ -e .git/HEAD -a -n "$(shell which git)" ] && git log >CHANGES || true

baseinstall:
	strip $(NAME)
	install -m 0755 -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 man/chaosvpn.1 $(DESTDIR)$(PREFIX)/share/man/man1/
	install -m 0755 -d $(DESTDIR)$(PREFIX)/share/man/man5
	install -m 0644 man/chaosvpn.conf.5 $(DESTDIR)$(PREFIX)/share/man/man5/

	install -m 0755 -d $(DESTDIR)$(PREFIX)/sbin
	install -m 0755 $(NAME) $(DESTDIR)$(PREFIX)/sbin/

linuxinstall: baseinstall
	@if [ ! -e $(DESTDIR)$(TINCDIR)/chaosvpn.conf ] ; then \
		install -m 0755 -d $(DESTDIR)$(TINCDIR) ; \
		install -m 0600 chaosvpn.conf $(DESTDIR)$(TINCDIR)/chaosvpn.conf ; \
		echo "Created config File $(TINCDIR)/chaosvpn.conf"; \
	fi
	@if [ ! -e $(DESTDIR)$(TINCDIR)/warzone.conf ] ; then \
		install -m 0755 -d $(DESTDIR)$(TINCDIR) ; \
		install -m 0600 warzone.conf $(DESTDIR)$(TINCDIR)/warzone.conf ; \
		echo "Created config File $(TINCDIR)/warzone.conf"; \
	fi

install: linuxinstall

bsdinstall: baseinstall
	install -m 0755 freebsd.rc.d $(DESTDIR)$(PREFIX)/etc/rc.d/chaosvpn

	@if [ ! -e $(DESTDIR)$(TINCDIR)/chaosvpn.conf ] ; then \
		install -m 0755 -d $(DESTDIR)$(TINCDIR) ; \
		install -m 0600 chaosvpn.conf.freebsd $(DESTDIR)$(TINCDIR)/chaosvpn.conf ; \
		echo "Created config File $(TINCDIR)/chaosvpn.conf from BSD template"; \
	fi

appleinstall: baseinstall
	# **FIXME** NEED REPLACEMENT - install -m 0755 freebsd.rc.d $(DESTDIR)$(PREFIX)/etc/rc.d/chaosvpn

	@if [ ! -e $(DESTDIR)$(TINCDIR)/chaosvpn.conf ] ; then \
		install -m 0755 -d $(DESTDIR)$(TINCDIR) ; \
		install -m 0600 chaosvpn.conf.apple $(DESTDIR)$(TINCDIR)/chaosvpn.conf ; \
		echo "Created config File $(TINCDIR)/chaosvpn.conf from Apple template"; \
	fi

splint:
	splint +posixlib +allglobals -type -mayaliasunique -predboolint \
		-retvalint $(CFLAGS) main.c $(SRC)

deb:
	[ -n "$(GITDEBVERSION)" ] # check if gitversion is set
	dpkg-checkbuilddeps
	@if git commit --dry-run -- debian/changelog >/dev/null 2>/dev/null ; then \
		echo -e "\nERROR: uncommited changes in debian/changelog!\n       either commit or revert with 'git checkout debian/changelog'\n" ; \
		exit 1 ; \
	fi
	@if git commit --dry-run -- version.h >/dev/null 2>/dev/null ; then \
		echo -e "\nERROR: uncommited changes in version.h!\n       either commit or revert with 'git checkout version.h'\n" ; \
		exit 1 ; \
	fi
	debchange --noquery --preserve --force-bad-version --newversion $(GITDEBVERSION) "Compiled GIT snapshot."
	echo "#define VERSION \"$(GITDEBVERSION)\"" >version.h
	debuild --no-tgz-check || true
	git checkout -- debian/changelog version.h
	@echo -e "\nDebian build successfull.";

=== httplib/Makefile ===
CC=gcc
INCLUDES=-I/usr/local/include
LIBDIRS=-L/usr/local/lib
CFLAGS=-std=c99 -D_POSIX_C_SOURCE=2 -D_BSD_SOURCE -D_FILE_OFFSET_BITS=64 -O0 -Wall -g
LIB=

STRINGSRC=../string/string_clear.c ../string/string_concatb.c ../string/string_concat_sprintf.c ../string/string_putc.c ../string/string_putint.c ../string/string_concat.c ../string/string_free.c ../string/string_get.c ../string/string_init.c ../string/string_equals.c ../string/string_move.c ../string/string_initfromstringz.c ../string/string_lazyinit.c
SRC = http_get.c http_parseurl.c $(STRINGSRC)
STRINGOBJ=$(patsubst %.c,%.o,$(STRINGSRC))
OBJ=$(patsubst %.c,%.o,$(SRC))

NAME = test_httplib

$(NAME): test.o $(OBJ)
	$(CC) -o $@ test.o $(OBJ) $(LIB) $(LIBDIRS)

%.o: %.c
	$(CC) $(CFLAGS) -o $(patsubst %.c,%.o,$<) -c $<

clean:
	rm -f *.o $(NAME)

=== nsis/Makefile ===
all: installer

chaosvpn.exe: ../chaosvpn
	cp ../chaosvpn chaosvpn.exe	
	strip chaosvpn.exe

LICENSE.txt: ../LICENCE
	cp ../LICENCE LICENSE.txt
	todos LICENSE.txt

README.txt: ../README
	cp ../README README.txt
	todos README.txt

chaosvpn.1.html: ../man/chaosvpn.1
	w3mman2html $< > $@

chaosvpn.conf.5.html: ../man/chaosvpn.conf.5
	w3mman2html $< > $@

installer: chaosvpn.nsi chaosvpn.exe chaosvpn.conf LICENSE.txt README.txt chaosvpn.1.html chaosvpn.conf.5.html
	makensis $<

clean:
	rm -f *.txt *.exe *.html

.PHONY: installer clean

=== debian/changelog ===
chaosvpn (2.18-0) unstable; urgency=low

  * Include chaosvpn.conf template for OpenBSD.
  * Do not automatically restart tincd if it aborted cleanly with
    a fatal error.
    Can happen for example with config incompatibilities between tinc
    and chaosvpn, or if two instances of the same node are running on
    two different hosts and the conflict-resolution in tinc decided
    to kill one.
  * calcdebversion: Make the version number in "make deb" look nicer.
  * Created test_addrmask.c, a small test program to verify that the
    addressmask parsing and output functions work on a system.
    Use it as 'make test_addrmask && ./test_addrmask'
  * Makefile: Use BSD gcc parameters for all kinds of BSD, not just FreeBSD
  * addrmask_to_string(): use inet_ntop() on unix, and getnameinfo() only on
    win32 - fixes NetBSD support.
  * Added a couple of internal cleanups.

 -- Sven-Haegar Koch <haegar@sdinet.de>  Thu, 01 Aug 2013 19:42:44 +0200

chaosvpn (2.17-0) unstable; urgency=low

  * addrmask_parse(): Fixed IP address parsing under OpenWRT by setting a
    missing ai_socktype for getaddrinfo() calls.
    Thanks to Thorben Went for debugging this.
  * addrmask.c: Fixed compile error on FreeBSD by including missing
    netinet/in.h
  * Fixed handling of nodes marked as silent=1
  * Added a couple of Apple OSX workarounds.
  * Added "make appleinstall" Makefile target.
  * More FreeBSD fixes.
  * Allow $tincd_bin to be specified as a relative path, searching for
    it in $PATH
  * tinc 1.1pre support: Starting with current git (and 1.1pre7) the binary
    that was called 'tincctl' is now just called 'tinc'. So change the
    default value and introduce new $tincctl_bin config variable.
  * warn only once about each unknown remote configstatement
  * support new central config statement ecdsapublickey= and if present
    and using tinc 1.1pre+ save it to hosts files.
  * Allow pingtest= in central config, but ignore it in client.
    (May be used later to automatically build icinga config or something
    like this)

 -- Sven-Haegar Koch <haegar@sdinet.de>  Fri, 12 Jul 2013 00:03:46 +0200

chaosvpn (2.15-0) unstable; urgency=low

  * Restore previous subnet-up/down behaviour for non-windows compiles.
  * addrmask.c: fix parsing and printing of ip addresses, got broken
    when implementing compiling under windows.
  * tinc.c: ensure all the strings used as char* are zero terminated.
  * make deb: fix to work with git tags starting with a "v" like "v2.14"

 -- Sven-Haegar Koch <haegar@sdinet.de>  Thu, 20 Sep 2012 21:16:21 +0200

chaosvpn (2.14-0) unstable; urgency=low

  * Disable forwarding of broadcast packets - right now we have OSPF
    traffic on the VPN creating useless traffic.
  * Letting tinc use ipv6 as the transport protocol only creates problems
    for now, so reduced transport protocol to ipv4 only.
  * FreeBSD compilation fixes.
  * Windows compilation works for the first time, thanks to Guus!
    (But support not finished yet)
  * Compiled Debian Wheezy and Unstable packages with hardening enabled.

 -- Sven-Haegar Koch <haegar@sdinet.de>  Tue, 28 Aug 2012 12:38:47 +0200

chaosvpn (2.12-0) unstable; urgency=low

  * Support (and use by default) tinc 1.0.17+ option LocalDiscovery=yes

 -- Sven-Haegar Koch <haegar@sdinet.de>  Sat, 10 Mar 2012 16:03:34 +0100

chaosvpn (2.11-0) unstable; urgency=low

  * Do not write Address= lines in tinc hosts files for hidden=1 nodes.
  * New config option $tincd_raw_config
  * Change default of AddressFamily back to 'ipv4'.
    The previous default of 'any' creates reachability problems for nodes
    reachable over ipv4 and ipv6 talking to ipv4-only nodes.
  * Some smaller internal changes.

 -- Sven-Haegar Koch <haegar@sdinet.de>  Mon, 18 Jul 2011 12:59:36 +0200

chaosvpn (2.10-0) unstable; urgency=low

  * Lots of bugfixes.
  * Configuration option tincd_user to run tincd as non-root
    (Currently not active in the debian package, to be fixed)
  * Rework structure: make main chaosvpn process *completely* unprivileged
    (Currently not active in the debian package, to be fixed)
  * Option for the local admin to merge lots of chaosvpn routes into a
    small number of bigger supernet routes.
  * Option for the local admin to blacklist/whitelist routes received from
    the vpn.
  * Debian packaging switched from crontab/oneshot mode to daemon mode.

 -- Sven-Haegar Koch <haegar@sdinet.de>  Fri, 27 May 2011 17:03:43 +0200

chaosvpn (2.06-0) unstable; urgency=low

  * Check that the OpenSSL headers used match the version of the
    OpenSSL library used.
    Output a warning if not.
    (Suggestion from wopot)
  * Added dependency to iproute package, needed for routing setup.

 -- Sven-Haegar Koch <haegar@sdinet.de>  Thu, 27 Jan 2011 01:10:16 +0100

chaosvpn (2.05-0) unstable; urgency=low

  * Fixing segfault in log.c on 64bit linux (32bit linux worked).
    The combination of va_start(), vsyslog(), vfprintf(), va_end()
    seems invalid using 64bit glibc, in 32bit using the same version
    everything is great.
    va_start(), vsyslog(), va_end(), va_start(), vfprintf(), va_end()
    seems to work on both architectures.

 -- Sven-Haegar Koch <haegar@sdinet.de>  Mon, 22 Nov 2010 00:25:17 +0100

chaosvpn (2.04-1) unstable; urgency=low

  * Logging changes: do not output everything to stderr, only errors.
    Way nicer for cronjobs.

 -- Sven-Haegar Koch <haegar@sdinet.de>  Sun, 21 Nov 2010 22:06:01 +0100

chaosvpn (2.03-1) unstable; urgency=low

  * dash does not support $RADOM, which is used in Debian cronjob.
    Package now requires bash instead until I find a better solution.

 -- Sven-Haegar Koch <haegar@sdinet.de>  Sun, 21 Nov 2010 21:31:07 +0100

chaosvpn (2.02-1) unstable; urgency=low

  * Busybox ash does not support "case" statement fall-through, repeat
    the needed blocks instead.
    Repairs $use_dynamic_routes feature on embedded machines.

 -- Sven-Haegar Koch <haegar@sdinet.de>  Thu, 11 Nov 2010 17:11:02 +0100



=== debian/control ===
Source: chaosvpn
Section: net
Priority: extra
Maintainer: ChaosVPN Mailinglist <chaosvpn@hamburg.ccc.de>
Uploaders: Sven-Haegar Koch <haegar@sdinet.de>
Build-Depends: debhelper (>= 7.0.15~), bison, flex, libssl-dev (>= 0.9.8), zlib1g-dev
Standards-Version: 3.9.4
Homepage: http://github.com/ryd/chaosvpn

Package: chaosvpn
Architecture: any
Depends: tinc (>= 1.0.13~), ${shlibs:Depends}, ${misc:Depends}, perl-base (>= 5.8.0), bash (>= 2), iproute
Description: Config generator to setup connection to ChaosVPN
 ChaosVPN is a tinc based VPN intended to connect Chaos and Hackerspaces,
 and their active members.
 .
 This software downloads the central node configuration, verifies it,
 creates tinc configs based on it and takes care of (re)starting tincd.
 .
 It replaces the "old" ChaosVPN from 2006.
Homepage: http://wiki.hamburg.ccc.de/ChaosVPN

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CPPFLAGS	:= $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get CPPFLAGS)
CFLAGS		:= $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get CFLAGS)
CXXFLAGS	:= $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get CXXFLAGS)
LDFLAGS		:= $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get LDFLAGS)

build: build-arch build-indep

build-arch: build-stamp

build-indep:

build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	CFLAGS='$(CFLAGS) $(CPPFLAGS)' LDFLAGS='$(LDFLAGS)' $(MAKE)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) clean

	# running $(MAKE) CHANGES in clean target to have changelog as part
	# of the generated debian source package
	[ -e .git/HEAD -a -n "$(shell which git)" ] && rm -f CHANGES || true
	-$(MAKE) CHANGES

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/<packagename>
	$(MAKE) DESTDIR=`pwd`/debian/`dh_listpackages`/ install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	if [ -e CHANGES ] ; then \
		dh_installchangelogs CHANGES ; \
	else \
		dh_installchangelogs ; \
	fi
	dh_installdocs
	dh_installexamples
	dh_install
	dh_installman
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installcatalogs
#	dh_installpam
	dh_installppp
#	dh_installmime
	dh_installinit --error-handler=invokerc_error
	dh_installcron
#	dh_installinfo
#	dh_installwm
#	dh_installudev
	dh_lintian
#	dh_bugfiles
#	dh_undocumented
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
